PROGRAM CIPHER;
{Program ciphering one block of text in form of the hexadecimal characters.}
uses crt;

TYPE
   gl32array = array [1..32] of integer;
   gl48array = array [1..48] of integer;
   gl56array = array [1..56] of integer;
   gl64array = array [1..64] of integer;

VAR
   ipp: gl32array;
   ipc2,iet: gl48array;
   glicd,ipc1: gl56array;
   ip,ipm,input,key,jotput: gl64array;
   is: array[1..16,1..4,1..8] of integer;
   ibin: array[1..4,1..16] of integer;
   hexinbin: array[1..4,0..15] of integer;
   i,j,int,weight:integer;
   desflg,ksflg,cyflg: boolean;
   htext,hkey:string[16];
   oper:char;
   infile:text;

{$I modfile.pas}
{$I desks.pas}
{$I des.pas}

PROCEDURE HEXTOBIN(htext:string; var result:gl64array);
{Converts hexadecimal digits to binary form}
BEGIN
   for i:=1 to 16 do begin         {Conversion hexadecimal to integer.}
     if (htext[i]>='0') and (htext[i]<='9') then int:=ord(htext[i])-ord('0')
        else int:=ord(htext[i])-ord('a')+10;
     for j:=4 downto 1 do begin       {Conversion integer to binary.}
        result[(i-1)*4+j]:=int mod 2;
        int:=int div 2;
     end;
   end;
END;

PROCEDURE BINTOHEX(joutput:gl64array);
{Converts binary numbe to printed hexadecimal equivalent}
BEGIN
   write('Cipher hex: ');
   for i:=1 to 16 do begin
     int:=0;
     weight:=1;                   {Conversion binary to integer.}
     for j:=1 to 4 do begin
       int:=int+jotput[((i-1)*4+5-j)]*weight;
       weight:=weight*2;
     end;                          {Conversion intger to hexadecimal.}
     if int<=9 then write(chr(int+ord('0')),'   ')
       else write((chr(int-10+ord('a'))),'   ');
   end;
END;

BEGIN          {Main program}
   clrscr; writeln;
   writeln('*** PROGRAM CIPHER ***'); writeln;
   writeln('Type plaintext <16 hexadecimal characters [0..f] + ENTER>:');
   write('0000000000000000'); gotoxy(1,5);
   readln(htext);
   htext:=htext+'0000000000000000';
   write('Text hex:   ');
   for i:=1 to 16 do write(htext[i],'   '); writeln;
   HEXTOBIN(htext,input);
   write('Text bin:   ');
   for i:=1 to 64 do write(input[i]); writeln; writeln;
   writeln('Type Key <16 hexadecimal characters [0..f] + ENTER>:');
   write('0000000000000000'); gotoxy(1,10);
   readln(hkey);
   hkey:=hkey+'0000000000000000';
   write('Key hex:    ');
   for i:=1 to 16 do write(hkey[i],'   '); writeln;
   HEXTOBIN(hkey,key);
   write('Key bin:    '); for i:=1 to 64 do write(key[i]); writeln; writeln;
   ksflg:=true;   cyflg:=true; desflg:=true;
   write('Ciphering is running...');
   DES(input,key,jotput);
   writeln('Done.'); writeln;
   BINTOHEX(jotput);
   writeln;
   write('Cipher bin: '); for i:=1 to 64 do write(jotput[i]); writeln;
   writeln; writeln('Press ENTER');
   readln;
END.
